<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iPcPathFinder Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iPcPathFinder Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iPcPathFinder" --><!-- doxytag: inherits="iBase" -->
<p>This is a pathfinder property class.  
 <a href="structiPcPathFinder.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="pathfinder_8h_source.html">propclass/pathfinder.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iPcPathFinder:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiPcPathFinder.png" usemap="#iPcPathFinder_map" alt=""/>
  <map id="iPcPathFinder_map" name="iPcPathFinder_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,92,24"/>
</map>
 </div></div>

<p><a href="structiPcPathFinder-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcPathFinder.html#a6e440b7bd3ac940a86364fc209a3f0c8">Interrupt</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Interrupt a movement.  <a href="#a6e440b7bd3ac940a86364fc209a3f0c8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiPcPathFinder.html#a2e5a2930fde1e3109df746cd51d6cbbe">Seek</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *sector, const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;position)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Move to the specified position.  <a href="#a2e5a2930fde1e3109df746cd51d6cbbe"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is a pathfinder property class. </p>
<p>It works closely with pcsteer in order to move an object from one position to another using celgraph to navigate correctly through the map.</p>
<p>This property class can send out the following messages:</p>
<ul>
<li>'cel.move.interrupted' (old 'pcpathfinder_interrupted'): movement has been interrupted.</li>
</ul>
<p>This property class supports the following actions (add prefix 'cel.move.pathfinder.action.' if you want to access this action through a message):</p>
<ul>
<li>Seek: parameters 'sectorname' (string), 'position' (vector3).</li>
<li>Wander: parameters 'distance' (int).</li>
<li>Pursue: parameters 'target' (iCelEntity*), 'max_prediction' (float).</li>
<li>FollowCyclicPath: parameters 'path' (iCelPath*).</li>
<li>FollowOneWayPath: parameters 'path' (iCelPath*).</li>
<li>FollowTwoWayPath: parameters 'path' (iCelPath*).</li>
<li>Interrupt: interrupt the current movement.</li>
</ul>
<p>This property class supports the following properties:</p>
<ul>
<li>position (vector3, read only): current end position.</li>
<li>active (bool, read only): returns true if currently tracking.</li>
<li>pursue_max_prediction (float, read/write): current max prediction</li>
<li>min_distance (float, read/write): current min distance to check when arriving to check points (nodes). </li>
</ul>

<p>Definition at line <a class="el" href="pathfinder_8h_source.html#l00057">57</a> of file <a class="el" href="pathfinder_8h_source.html">pathfinder.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a6e440b7bd3ac940a86364fc209a3f0c8"></a><!-- doxytag: member="iPcPathFinder::Interrupt" ref="a6e440b7bd3ac940a86364fc209a3f0c8" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiPcPathFinder.html#a6e440b7bd3ac940a86364fc209a3f0c8">iPcPathFinder::Interrupt</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Interrupt a movement. </p>
<p>The behaviour will get a 'pcmover_interrupted' message if the mover was really moving. Otherwise nothing happens. </p>

</div>
</div>
<a class="anchor" id="a2e5a2930fde1e3109df746cd51d6cbbe"></a><!-- doxytag: member="iPcPathFinder::Seek" ref="a2e5a2930fde1e3109df746cd51d6cbbe" args="(iSector *sector, const csVector3 &amp;position)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="structiPcPathFinder.html#a2e5a2930fde1e3109df746cd51d6cbbe">iPcPathFinder::Seek</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a> *&#160;</td>
          <td class="paramname"><em>sector</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a> &amp;&#160;</td>
          <td class="paramname"><em>position</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Move to the specified position. </p>
<p>When you call this function this property class will attempt to move the linmove to the correct position. If it fails the behaviour will get a 'pcmover_stuck' message. Otherwise it will get a 'pcmover_arrived' message. If checklos parameter is true a line of sight test will be made in advance, and if this function detects that line of sight is blocked then the behaviour will get a 'pcmover_impossible' message and this function will return false then. If this property class was already controlling a movement then that movement will be interrupted (possibly giving a pcmover_interrupted message). </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">sector</td><td>is the desired sector to move to. </td></tr>
    <tr><td class="paramname">position</td><td>is the desired position to move to. </td></tr>
    <tr><td class="paramname">sqradius</td><td>if the linmove ends up within the given squared radius of the desired position the movement will stop and be considered sucessful. </td></tr>
    <tr><td class="paramname">checklos</td><td>whether to check line of sight to destination on movement start. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>propclass/<a class="el" href="pathfinder_8h_source.html">pathfinder.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
